"""
A list-like approach:
 [+ 3 4]
 [+ 3 [- 5 1]]

With a graph-like approach, we need a rooted, directed tree (no necessarily
binary).
 vertices:
   [+ 3 4]
 edges:
   [(+, 3), (+, 4)]

 vertices:
   [+ 3 - 5 1]
 edges:
   [(+, 3), (+, -), (-, 5), (-, 1)]

We need a data structure that will meet the following conditions:
 1) store vertices
 2) store nodes
 3) allow graph theoretic operations on both
 4) allow nodes to be arbitrary python objects (in the case of pyLisp-NG, these
    would be the symbol objects)
 5) provide a means of tracking the parents of each vertex and the children of
    each vertex
 6) meets specified graph-theoretic requirements/definitions

Terms (each of the following should have some representation in the final
implementation):
 * graph - consists of two types of elements -- vertices and edges -- where
   every edge has two endpoints in the set of vertices, and connects the two
   endpoints
 * vertex - the vertex set of graph G is usually denoted by V(G), or V when
   there is no danger of confusion
 * edge - a set of two vertices; in the case of a directed graph, a directed
   graph, it is an ordered pair
 * order - the number of a graph's vertices: |V(G)|
 * source - 
 * sink
 * tree
 * subtree
 * forest
 * subforest
 * incidence 
 * order
 * degree
 * depth
 * length
 * neighbor/adjacency
 * directed graph
 * directed acyclic graph
 * transitive reduction
 * transitive closure
 * reachability relation
 * parse tree/concrete syntax tree
 * rooted tree
 * interior-nodes
 * root node
 * terminal node
 * leaf nodes
 * abstract syntax trees
 * matrix representations
 * list representations
"""
