"""
Wikipedia references:
    http://en.wikipedia.org/wiki/Binary_tree
    http://en.wikipedia.org/wiki/Breadth-first_search
    http://en.wikipedia.org/wiki/Depth-limited_search
    http://en.wikipedia.org/wiki/Depth-first_search
    http://en.wikipedia.org/wiki/Glossary_of_graph_theory

Other references:
    http://www.ics.uci.edu/~eppstein/PADS/Graphs.py
    http://www.python.org/doc/essays/graphs.html
    http://wiki.python.org/moin/PythonGraphApi
"""

"""

Example 1
=========

Tree:

       +
      / \
     1   2

S-Expressioni string:

    (+ 1 2)

S-Expressioni list object:

    e = SExpression()
    e.append('+')
    e.append('1')
    e.append('2')

"""


"""

Example 2
=========

Tree:

       +
      / \
     1   *
        / \
       -   3
      / \
     7   2

S-Expressioni string:

    (+ 1 (* (- 7 2) 3))

S-Expressioni list object:

    e1 = SExpression()
    e2 = SExpression()
    e3 = SExpression()

    e3.append('-')
    e3.append('7')
    e3.append('2')

    e2.append('*')
    e2.append(e3)
    e2.append('3')

    e1.append('+')
    e1.append('1')
    e1.append(e2)

S=Expression graph object:

    e1 = Graph()
    e3 = Vertex('-')
    e3.add_edge('7')
    e3.add_edge('2')

    e2 = Vertex('*')
    e2.add_edge(
    e.add_vertex(v1)

"""

get_chilren
get_parent

edge - conntects vertices

# binary tree - 
#   node.left_child
#   node.right_child
#   node.parent
#
#   node with index i has:
#       children at 2i + 1 (left child) and 2i + 2 (right child)
#       parent at (i -1)/2
#       root index = 0


# n-ary tree (arity, for the context of these operations)
#   node.children (children is a list; the parent operation applies to each
#       child in order
#   node.parent
#
#   node with index i has:
#       children at 

"""

define a graph
add a root node - increment the graph node count
                - parent = None
                - children get updated dynamically as they are added
                - arity is calculataed/set based on the type of node that was
                  added
add an edge + node - increment the graph edge and node count
                   - parent = root
                   - updates parent.children (append)

nodes have .parent, .children, .arity (arity must equal len(children))

with each node that is added, the graph's 'nodes' attribute is appeded to. as
such, all nodes are accessible in a flat list. a node that is accessed via
graph.nodes will have the complete but the node objects have 
"""

class Graph(object):
    def __init__(self):
        self.vertices = []
    def add_vertex(self, vertex):
        self.vertices.append(vertex)
    def add_edge(self, vertex1, vertex2):
        self.edges.append((vertex1, vertex2))
        
class Vertex(object):
    def __init__(self):
        self.parent = None
        self.children = []

class Edge(object):
    pass

class Unary(Vertex):
    arity = 1

class Binary(Vertex):
    arity = 2

class Ternary(Vertex):
    arity = 3

class Multinary(Vertex):
    arity = None
